package dev.shadowsoffire.apotheosis.ench.table;

import net.minecraftforge.common.capabilities.ForgeCapabilities;
import net.minecraft.core.Direction;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraft.nbt.Tag;
import net.minecraft.nbt.CompoundTag;
import net.minecraftforge.common.Tags;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.core.BlockPos;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.common.util.LazyOptional;
import net.minecraftforge.items.ItemStackHandler;
import net.minecraft.world.level.block.entity.EnchantmentTableBlockEntity;

public class ApothEnchantTile extends EnchantmentTableBlockEntity
{
    protected ItemStackHandler inv;
    LazyOptional<IItemHandler> invCap;
    
    public ApothEnchantTile(final BlockPos pos, final BlockState state) {
        super(pos, state);
        this.inv = new ItemStackHandler(1) {
            public boolean isItemValid(final int slot, final ItemStack stack) {
                return stack.m_204117_(Tags.Items.ENCHANTING_FUELS);
            }
        };
        this.invCap = (LazyOptional<IItemHandler>)LazyOptional.of(() -> this.inv);
    }
    
    public void m_183515_(final CompoundTag tag) {
        super.m_183515_(tag);
        tag.m_128365_("inventory", (Tag)this.inv.serializeNBT());
    }
    
    public void m_142466_(final CompoundTag tag) {
        super.m_142466_(tag);
        this.inv.deserializeNBT(tag.m_128469_("inventory"));
    }
    
    public <T> LazyOptional<T> getCapability(final Capability<T> cap, final Direction side) {
        if (cap == ForgeCapabilities.ITEM_HANDLER) {
            return (LazyOptional<T>)this.invCap.cast();
        }
        return (LazyOptional<T>)super.getCapability((Capability)cap, side);
    }
    
    public void invalidateCaps() {
        super.invalidateCaps();
        this.invCap.invalidate();
    }
    
    public void reviveCaps() {
        super.reviveCaps();
        this.invCap = (LazyOptional<IItemHandler>)LazyOptional.of(() -> this.inv);
    }
}
